***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### coulAsympt ###	
c
c     mpole multipole moments (stored in cmulti) and associated Legendre
c     functions are used to calculate for each i=1,nni 4 boundary values
c     of Coulomb potential for a given orbital ($\tilde{V}^a_C$)),
c     i.e. its values for j=mxnmu-3, mxnmu-2, mxnmu-1,mxnmu

      subroutine coulAsympt(iorb,pot)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension pot(*)

      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            rr=sqrt(vxisq(j)+vetasq(i)-1.d0)
            rr1=1.d0/(rr*r2)
            costh=veta(i)*vxi(j)/rr
            pot(kk)=r2*vxi(j)*(rr1+vcoul(iorb,i,j,costh))
         enddo
      enddo

      return
      end
