
***************************************************************************
*                                                                         *
*   Copyright (C) 1992 F.A. Parpia and I.P. Grant                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### etotalGauss ###
c
c     Evaluate the interaction energy between two nuclei with Gaussian
c     charge distributions Z1*Z2/r lowerGamma(half,eta12*r*r)/sqrt(pi),
c     1/eta12=1/eta1+1/eta2

      subroutine etotalGauss
      implicit integer*4 (i-n)
      implicit real*8 (A-H, O-Z)
      include 'commons8.inc'

      fmtoau=1.0d-13/ainfcm

      if (z1.eq.0.d0) then
         eta1=1.d35
      endif

      if (z2.eq.0.d0) then
         eta2=1.d35
      endif
      
      atw=z1atmass
      at3=atw**(one/three)
      rrmsfm = 0.836d0*at3+0.570d0
      rrms = rrmsfm*fmtoau
      eta1=3.d0/(2.d0*rrms*rrms)

      atw=z2atmass
      at3=atw**(one/three)
      rrmsfm = 0.836d0*at3+0.570d0
      rrms = rrmsfm*fmtoau
      eta2=3.d0/(2.d0*rrms*rrms)

      eta12=eta1*eta2/(eta1+eta2)
c     lower incomplete gamma function 
      gammaLower=(eta12*r*r)**(half)*dgamma(half)*dgamit(half,eta12*r*r)
      etotFN=etot-z1*z2/r+z1*z2*gammaLower/r/sqrt(pii)

      return
      end
