***************************************************************************
*                                                                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### exbe88sup ###

c     Calculates exchange energy according to Becke's gradient formula
c     (PRA 88 (1988) 3098-3100)

      real*8 function exbe88sup (wgt2,rho,grho,wk0,wk1)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (const13=1.d0/3.d0,const43=4.d0/3.d0,const83=8.d0/3.d0,
     &     const115=1.d0/15.d0,bbeta=0.0042)

      include 'commons8.inc'	
      dimension wgt2(*),rho(*),grho(*),wk0(*),wk1(*)

      ash(s)=log(s+sqrt(1.d0+s*s))

c      grho = nabla rho  nabla rho
c      |nabla rho| = sqrt(grho)

      do i=1,mxsize
         if (abs(rho(i)).lt.precis) then
            wk0(i)=0.d0
         else
            rho43=rho(i)**const43
            s2=grho(i)/(rho43*rho43)
            s=sqrt(s2)
c           fgga=-bbeta*s2/(one+6.d0*bbeta*s*asinh(s))
            wk0(i)=-bbeta*s2/(one+6.d0*bbeta*s*ash(s))*rho43
         endif
      enddo	  

c     take care of f4 factor
      call multf4(wk0)

      exbe88sup=dot(mxsize,wgt2,ione,wk0,ione)

      return
      end


