***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### exchAsympt ###

c     Evaluates asymptotic values of a given exchange potential from the
c     multipole expansion.

c     excptail array is used to provide asymptotic values for 'immersed'
c     exchange potentials (see fill).

c     For odd values of q in P(k,q) (here q=idel) there should be no
c     (-1)**q factor in eq. (19). That is why this factor is missing in
c     this routine.

      subroutine exchAsympt (idel,ipc,excp)
      implicit integer*4 (i-n)
      implicit real*8(a-h,o-z)
      include 'commons8.inc'
      dimension excp(*),pe(maxmpole)
c      vxil(j) =cosh(dble(j-1)*hmu(1))

      do j=mxnmu-3,mxnmu
         itt=(j-1)*nni
         do i=1,nni
            kk=i+itt
            call vexch(i,j,idel,ipc,pe)
            excp(kk)= r2*vxi(j)*pe(mpole)
         enddo
      enddo
      
      return
      end
