***************************************************************************
*                                                                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### fbe88 ###

c     Calculates the Becke gradient-corrected exchange potential (PRA 88
c     (1988) 3098-3100)

      subroutine fbe88 (psi,f4,rhot,rhotup,rhotdown,
     &     grhot,grhotup,grhotdown,wk0,wk1,wk2,wk3,wk4,
     &     wk5,wk6,wk7)

      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (const13=1.d0/3.d0,const43=4.d0/3.d0,
     &     const115=1.d0/15.d0)
      include 'commons8.inc'	

      dimension psi(*),f4(*),wk0(*),wk1(*),wk2(*),wk3(*),wk4(*),
     &     wk5(*),wk6(*),wk7(*),rhot(*),rhotup(*),rhotdown(*),
     &     grhot(*),grhotup(*),grhotdown(*)

      
      do i=1,mxsize
         rhotup(i)   =0.d0
         rhotdown(i) =0.d0
      enddo	  
      
c     calculate total densities due to up and down spins
      do iorb=1,norb
         iborb=i1b(iorb)
         isiorb=i1si(iorb)
         nmut=i1mu(iorb)
         
         call exocc (iorb,ocup,ocdown)

         call prod2 (isiorb,psi(iborb),psi(iborb),wk1)
         call scal (isiorb,ocup,wk1,ione)
         
         call prod2 (isiorb,psi(iborb),psi(iborb),wk2)
         call scal (isiorb,ocdown,wk2,ione)
       
c        store total densities 
         call add(isiorb,wk1,rhotup)
         call add(isiorb,wk2,rhotdown)
      enddo

      call fbe88sup (rhotup,grhotup,rhot,
     &     wk0,wk1,wk2,wk3,wk4,wk5,wk6,wk7)

      call fbe88sup (rhotdown,grhotdown,rhot,
     &     wk0,wk1,wk2,wk3,wk4,wk5,wk6,wk7)

      call copy(mxsize,grhotup,ione,wk2,ione)
      call add (mxsize,grhotdown,wk2)

      call prod (mxsize,f4,wk2)
      return
      end
