***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### inCard ### 
c
c     This routine reads )and echoes) a single data card and 
c
c       - changes upper case letters into a lower case ones
c       - changes tabs (if any) into spaces
c       - removes leading spaces
c
c     Then it scans the line for nonspace fields. The number of fields
c     is stored in jump, the starting point of a given field in istrt(i)
c     and the number of characters in that field in inumb(i). If the
c     routine finds an exclamation mark or a hash then anything on the
c     same line that follows these characters is treated as a comment.

      subroutine inCard
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (i40=40, i80=80)
      character*1 ia,exm,blnk,hash
      character*1 iatmp(80)
      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(i40),inumb(i40),ia(i80)
      data blnk/' '/,exm/'!'/,hash/'#'/

      do i=1,i80
         ia(i)=' '
      enddo

c     read a line 

      jump = 0
      jrec = 0
      isw = 0
 1    read(iinp5,100,err=110,end=40) ia
 100  format(80a1)
 101  format(2x,80a1)
 110  continue

      do i=1,i80
         iatmp(i)=ia(i)
      enddo

c     set into lower case 
c     FC3, ifort: error while passing i80 to a subroutine                                                                     
      it=i80
      call lowcase(iatmp,it)

c     check for tabs, and replace them by blanks
      call tabchk(iatmp,it)

c     check for blanks at left and remove them, fill with blanks at the end  
      call lftpos(iatmp,it) 

      do i=1,i80
         ia(i)=iatmp(i)
      enddo


c     check for an exclamation mark or a hash
      do ike=1,i80
         ile=ike
         if (ia(ile).eq.exm.or.ia(ile).eq.hash) go to 910
      enddo 

 910  if(ile.eq.1) go to 1
c     echo the slightly modified input data
      write(iout6,101) ia 

      if(ia(ile).eq.exm.or.ia(ile).eq.hash) ile=ile-1

      do i = 1,ile 
         if (ia(i).eq.blnk) then 
            isw=0
            goto 30
         else
            if (isw.le.0) then 
               jump = jump +1
               istrt(jump) = i
               inumb(jump) = 0
               isw=1
               inumb(jump) = inumb(jump) + 1
            else
               inumb(jump) = inumb(jump) + 1
 5          endif
         endif
 30      continue
      enddo
      
      if (jump.eq.0) goto 1
      return

 40   write(iout6,45)
 45   format(//1x,'Error: unexpected end of input data.',
     &            ' Is STOP label missing?'//)
      stop 'inCard'
      end

***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### inCardh ### 
c
c     This routine reads a single data card (80 characters) and returns
c     the data from columns 6-80.

      subroutine inCardh(header80)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      parameter (i40=40, i80=80)
      character*1 ia,header,exm,blnk,hash
      character*1 iatmp(80)
      character*80 header80,h80
      dimension header(i80)
      common/iochan/ iinp5,iinp11,iinp12,iinp13,iinp14,
     &               iout6,iout21,iout22,iout23,iout24
      common/work/jrec,jump,istrt(i40),inumb(i40),ia(i80)
      data blnk/' '/,exm/'!'/,hash/'#'/
      equivalence(h80,header(1))

      do i=1,i80
         ia(i)=' '
      enddo

c     read a line 

      jump = 0
      jrec = 0
      isw = 0
 1    read(iinp5,100,err=110,end=40) ia
 100  format(80a1)
 101  format(2x,80a1)
 110  continue
      
      do i=1,i80
         iatmp(i)=ia(i)
      enddo

c     set into lower case 
c     FC3, ifort: error while passing i80 to a subroutine                                                                     
c     do not chane to lower case for header 
      it=5
      call lowcase(iatmp,it)

      it=i80
c     check for tabs, and replace them by blanks
      call tabchk(iatmp,it)

c     check for blanks at left and remove them, fill with blanks at the end  
      call lftpos(iatmp,it) 

      do i=1,i80
         ia(i)=iatmp(i)
      enddo


c     check for an exclamation mark or a hash
      do ike=1,i80
         ile=ike
         if (ia(ile).eq.exm.or.ia(ile).eq.hash) go to 910
      enddo 

 910  if(ile.eq.1) go to 1
c     echo the slightly modified input data
      write(iout6,101) ia 

      if(ia(ile).eq.exm.or.ia(ile).eq.hash) ile=ile-1

      do i = 1,ile 
         if (ia(i).eq.blnk) then 
            isw=0
            goto 30
         else
            if (isw.le.0) then 
               jump = jump +1
               istrt(jump) = i
               inumb(jump) = 0
               isw=1
               inumb(jump) = inumb(jump) + 1
            else
               inumb(jump) = inumb(jump) + 1
 5          endif
         endif
 30      continue
      enddo
      
      if (jump.eq.0) goto 1

      do i=6,i80
         header(i-5)=ia(i)
      enddo

      do i=i80,i80+5
         header(i-5)=blnk
      enddo

      header80=h80


      return

 40   write(iout6,45)
 45   format(//1x,'Error: unexpected end of input data.',
     &            ' Is STOP label missing?'//)
      stop 'inCardh'
      end

c ### lftpos ###
c
c Eliminates blanks to the left and left position chararcter string card.
c 
      subroutine lftpos(line,length)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 line(length)

      ieff = 0
      do ipos = 1, length
         if(ieff.gt.0) then
            ieff=ieff+1
            line(ieff) = line(ipos)
         end if
         if(line(ipos).ne.' '.and.ieff.eq.0) then
            ieff=1
            line(ieff) = line(ipos)
         end if 
      end do  

c     fill end with trailing blanks

      do ipos = ieff+1,length 
         line(ipos) = ' '
      end do 

      ntest = 0
      if(ntest.ne.0) then
         write(6,*) ' Left adjusted character string '
         write(6,'(1H ,A)') line
      end if

      return
      end

c ### lowcase ### 
c
c Converts letters in a character string line to the lower case.
c
      subroutine lowcase(line,length)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 line(length)
      character*1 lower(26)
      character*1 upper(26)

      data lower/'a','b','c','d','e',
     &           'f','g','h','i','j',
     &           'k','l','m','n','o',
     &           'p','q','r','s','t',
     &           'u','v','w','x','y',
     &           'z'/
      data upper/'A','B','C','D','E',
     &           'F','G','H','I','J',
     &           'K','L','M','N','O',
     &           'P','Q','R','S','T',
     &           'U','V','W','X','Y',
     &           'Z'/

      do icha = 1, length
         do i = 1,26
            if(line(icha).eq.upper(i))
     &           line(icha) = lower(i)
         end do  
      end do  
      return 
      end 


c ### tabchk ###
c
c     Searches for a tab in the string line and replace it by a space.
c
      subroutine tabchk(line,length)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      character*1 itab
      character*1 line(length)

      itab=char(9)
      do i=1,length
         if(line(i).eq.itab) then
            line(i)=' '
         end if
      end do
      return
      end















