***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### initArrays ###
c
c     Setup various arrays and variables

      subroutine initArrays (cw_suppl,cw_sor)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      integer*4 cw_sor
      include 'commons8.inc'
      dimension cw_suppl(*),cw_sor(*)

c     initialize arrays within common blocks (except for differentiating 
c     arrays which are defined in prepdiff) and check input data

      call initCBlocks

c     employ input data to determine size and division of cw arrays
c     initialize address arrays

      call initAddr

c     Initialises various supplementary arrays of case-dependent lengths
c
c     i4b(1)=borb
c     i4b(2)=bpot
c     i4b(3)=d
c     i4b(4)=e
c     i4b(5)=f0
c     i4b(6)=f1
c     i4b(7)=f2
c     i4b(8)=f3
c     i4b(9)=f4
c     i4b(10)=g
c     i4b(11)=wjac1
c     i4b(12)=wjac2
c     i4b(13)=wgt1
c     i4b(14)=wgt2

      call initSuppl (cw_suppl(i4b( 1)),cw_suppl(i4b( 2)), 
     &              cw_suppl(i4b( 3)),cw_suppl(i4b( 4)), 
     &              cw_suppl(i4b( 5)),cw_suppl(i4b( 6)), 
     &              cw_suppl(i4b( 7)),cw_suppl(i4b( 8)), 
     &              cw_suppl(i4b( 9)),cw_suppl(i4b(10)), 
     &              cw_suppl(i4b(11)),cw_suppl(i4b(12)), 
     &              cw_suppl(i4b(13)),cw_suppl(i4b(14)) )

c$$$c     initialize arrays used for evaluating first and second derivatives
c$$$
c$$$c       call initDiff (cw_suppl(i4b( 1)),cw_suppl(i4b( 3)))

c     prepare meshes for all subgrids

      call initMesh (cw_sor)

c     calculate weights of exchange contributions to the total energy
c     expression for the given open/closed shell scf case

      call initExWeights

      
      return
      end
