***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### pottf ###
c
c     Calculates a Thomas-Fermi potential (a modified version of dentfa
c     by Desclaux)

      function pottf(r,ek,qk,dz,ch,slim)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)                               

      pottf=0.d0
      if((dz+ch).lt.1.d-04)  return

      if(abs(qk+ek).lt.1.d-10) return

      w=r*(qk+ek)/2.d0*(dz+ch)**(1.d0/3.d0)
      w=sqrt(w/0.88534d0)
      t=w*(0.601120d0*w+1.810610d0)+1.d0
      w=w*(w*(w*(w*(0.047930d0*w+0.214650d0)+0.771120d0)+
     &     1.395150d0)+1.810610d0)+1.d0
      pottf=slim*(1.d0-(t/w)*(t/w))*2.d0/(r*(qk+ek))

      return
      end
