***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### putin3 ###

c     Immerses FUN array into WORK and adds boundary values: 
c     the interior subgrid

      subroutine putin3 (nni,nmi,fun,work)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      data n9/9/

      common/interp/ cint2(9,4),cint3l(9,4),cint3r(9,4),cint4(9,4),
     &		   iadint2(4),iadint3l(4),iadint3r(4),iadint4(4)
      common/sorwk/ omega,omega1,dmu2t(4),dmu1t(4),icase,ifill,
     &              isym,muoffs

      dimension fun(nni,*),work(nni+8,nmi+8),fint(2500,4)	

c     muoffs=iemu(ig-1)	
c     fill the interior of work array
c
      do i=1,nmi
         do j=1,nni
            work(j+4,i+4)=fun(j,muoffs+i)
         enddo
      enddo

c     values over i=1 bondary are determined from the interpolation formula
c     mu=2,...,4 from interpolation (coefficients from cint3l)

      do i=2,4
          call gemv (nni,n9,fun(1,iadint3l(i)),nni,cint3l(1,i),fint(1,i))
      enddo

      do i=2,4
         do j=1,nni
	    work(j+4,i)= fint(j,i)
         enddo
      enddo

c     values over i=nmi bondary are determined from the interpolation formula
c     mu=nmu+5....nmu+8 from interpolation (coefficients from cint3r)

      do i=1,4
          call gemv (nni,n9,fun(1,iadint3r(i)),nni,cint3r(1,i),fint(1,i))
      enddo

      do i=1,4
         do j=1,nni
	    work(j+4,nmi+4+i)= fint(j,i)
         enddo
      enddo

c     isym = 1 - even symmetry, isym =-1 - odd symmetry

      if (isym.eq.1) then

c ni=1...4
         do i=1,nmi
            do j=2,5
               work(6-j,i+4)= fun(j,muoffs+i)
            enddo
         enddo

c ni=ni+4...ni+8
	  do i=1,nmi
             jj=0
             do j=nni-4,nni-1
                jj=jj+1
                work(nni+9-jj,i+4)= fun(j,muoffs+i)
             enddo
          enddo
      else
	  do i=1,nmi
             do j=2,5
                work(6-j,i+4)=-fun(j,muoffs+i)
             enddo
          enddo

	  do i=1,nmi
             jj=0
             do j=nni-4,nni-1
                jj=jj+1
                work(nni+9-jj,i+4)=-fun(j,muoffs+i)
             enddo
          enddo
      endif

      return
      end
