***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### setCiOrb ###

c     sets Ci symmetry of a given orbital: the values from the [0,pi/2]
c     region replace those from [pi/2,pi] one

      subroutine setCiOrb (n2,nmut,orb,ihsym)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      include 'commons8.inc'
      dimension orb(nni,nmut)

      if (iprint(110).eq.0) then
c        set symmetry according to input data
         if (ihsym.eq.1) then
            do ni=1,n2-1
               do mi=1,nmut
                  orb(nni+1-ni,mi)= orb(ni,mi)
               enddo
            enddo
         else
            do ni=1,n2-1
               do mi=1,nmut
                  orb(nni+1-ni,mi)=-orb(ni,mi)
               enddo
            enddo
            do mi=1,nmut
               orb(n2,mi)=0.d0
            enddo   
         endif

      else

         mis=10
         nis=2
         
c        check symmetry at a given point and impose the same symmetry
c        at other other ones

         if (orb(nis,mis)*orb(nni-nis+1,mis).gt.0.d0) then
            do ni=1,n2-1
               do mi=1,nmut
                  orb(nni+1-ni,mi)= orb(ni,mi)
               enddo
            enddo
            ihsym= 1
         else
            do ni=1,n2-1
               do mi=1,nmut
                  orb(nni+1-ni,mi)=-orb(ni,mi)
               enddo
            enddo
c           
            do mi=1,nmut
               orb(n2,mi)=0.d0
            enddo
            ihsym=-1
         endif
      endif

      return
      end

