***************************************************************************
*                                                                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### tail ####
c
c     examines the tails of all orbitals and determines the location of
c     the last maximum in mu variable, i.e.
c     f(max)=max{vmax(1),vmax(2),...,vmax(nni)}
c     and the maximum value of psi at the last mi=nmi grid line

      subroutine tail (psi)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
c
      include 'commons8.inc'
      dimension psi(*)

      do iorb=1,norb
         ibeg=i1b(iorb)-1
         vpmax=-1.d30
         imaxg =0
         
         vpmax=-1.d30
         do ini=1,nni
            ijk=(mxnmu-1)*nni+ini
	    vp=abs(psi(ibeg+ijk))
	    if (vp.gt.vpmax) then
               vpmax=vp
               inimax=ini
            endif
         enddo 
         write(*,5110) 'tail: ',iorb,inimax,vpmax
      enddo

 5000 continue
      
 5100 format('   orbital     ni    max{psi(ni,mxnmui)}    ')
 5110 format(1x,a10,2i5,2x,e12.2)
      return
      end
