***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### add ###
c
c     a vector plus a vector: dy(i)=dx(i)+dy(i), i=1..n

      subroutine  add(n,dx,dy)
      integer*4 i,n
      real*8 dx(*),dy(*)

      do i = 1,n
        dy(i) = dy(i) + dx(i)
      enddo
      return
      end

c ### prod ###
c
c     a vector times a vector: dy(i)=dx(i)*dy(i), i=1..n

      subroutine prod(n,dx,dy)
      real*8	 dx(*),dy(*)
      integer*4 i,n

      do i = 1,n
         dy(i) = dy(i) * dx(i)
      enddo

      return
      end

c ### prod2 ###

c     a vector times a vector: dr(i)=dx(i)*dy(i), i=1..n

      subroutine   prod2(n,dx,dy,dr)
      real*8	 dx(*),dy(*),dr(*)
      integer*4 i,n

      do i = 1,n
        dr(i) = dx(i) * dy(i)
      enddo

      return
      end

c ### proda ###
c
c     a vector times a vector: dr(i)=dx(i)*dy(i)+r(i), i=1..n

      subroutine   proda(n,dx,dy,dr)
      real*8	 dx(*),dy(*),dr(*)
      integer*4 i,n

      do i = 1,n
         dr(i) = dx(i) * dy(i)+dr(i)
      enddo

      return
      end

c ### prodas ###

c     a vector times a vector: dr(i)=s*dx(i)*dy(i)+dr(i), i=1..n

      subroutine   prodas(n,s,dx,dy,dr)
      real*8	 dx(*),dy(*),dr(*),s
      integer*4 i,n

      do i = 1,n
         dr(i) = s*dx(i) * dy(i)+dr(i)
      enddo

      return
      end

