***************************************************************************
*                                                                         *
*   Copyright (C) 1996 Leif Laaksonen, Dage Sundholm                      *
*   Copyright (C) 1996-2010 Jacek Kobus <jkob@fizyka.umk.pl>              *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### vcoul ###		  	    

c     Evaluates and returns the boundary value of the Coulomb potential
c     for a given orbital at a given point ($\tilde{V}^a_C$))

      function vcoul(iorb,i,j,costh)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)		
      include 'commons8.inc'
      dimension dome(10)

      rr=sqrt(vxisq(j)+vetasq(i)-1.d0)
      rr1=1.d0/(rr*r2)
      
      dome(1)=costh
      dome(2)=(3.d0*costh*costh-1.d0)*5.d-01
      do n=2,mpole-1
         dome(n+1)=(dble(2*n+1)*costh*dome(n)-dble(n)*
     &        dome(n-1))/dble(n+1)
      enddo
            
      pe=0.d0
      rr2=rr1
      do m=1,mpole
c         rr2=rr2*rr1
         kxk=iorb+(m-1)*norb
         pe=pe+cmulti(kxk)*dome(m)*(rr1**dble(m+1))
c         pe=pe+cmulti(kxk)*dome(m)*rr2
      enddo 
      vcoul=pe
      return
      end
