***************************************************************************
*                                                                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### vlpcoeff ###  

c     This function uses the Horner scheme to calculate the value of a
c     polynomial defined by coefficients stored in array coeff at a
c     point r0
c     
c     vlpcoeff(r0)=coeff(1)+coeff(2)*r0+...+coeff(iord)*r0**(iord-1)

      real*8 function vlpcoeff (iord,r0,coeff)
      implicit integer*4 (i-n)
      implicit real*8 (a-h,o-z)
      dimension coeff(*)

      vlpcoeff=0.d0
      do i=iord,2,-1
         vlpcoeff=(vlpcoeff+coeff(i))*r0
      enddo
      vlpcoeff=vlpcoeff+coeff(1)
      return
      end
