***************************************************************************
*                                                                         *
*   Copyright (C) 1992 F.A. Parpia and I.P. Grant                         *
*   Copyright (C) 2010 Jacek Kobus <jkob@fizyka.umk.pl>                   *
*                                                                         *     
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License version 2 as     *
*   published by the Free Software Foundation.                            *
*                                                                         *
***************************************************************************
c ### zz1 ###
c
c     Evaluate the nuclear potential for Fermi models.  
c
c     This routine is based on nucpot routine from the GRASP2 package
c     (ver. 1.00, 1992)

      function zz2(i,j)
      implicit integer*4 (i-n) 
      implicit real*8 (a-h, o-z)
      include 'commons8.inc'

      if (z2.eq.0.d0) then
         zz2=0.d0
         return
      endif

      fmtoau=1.0d-13/ainfcm

c     Fermi distribution

c     potential energy is V(i,j)=-zz1(i,j)/r1 -z2/r2
c     set atomic weight for 

      atw=z2atmass
      at3=atw**(one/three)
      rrmsfm = 0.836d0*at3+0.570d0
      tfm = 2.30d0

c     change units from fm into bohr

      rrms = rrmsfm*fmtoau
      t = tfm*fmtoau  
      a = t/(4.0d0*log(3.0d0))         
      facto1 = rrms**2-(7.0d0/5.0d0)*(pii**2)*(a**2)
      c = sqrt (5.0d0/3.0d0) * sqrt (facto1) 
      abc = a/c
      tabc = two*abc
      abc2 = abc*abc
      thabc2 = three*abc2
      abc3 = abc2*abc
      cba = c/a
      pi2 = pii*pii
      hpiac2 = half*pi2*abc2
      six = two*three
      h3 = half*three
      h3php = h3+hpiac2                                              
      call es (-cba,s2mcba,s3mcba)
      sabc3 = six*abc3
      dmsas = -sabc3*s3mcba
      en = one + abc2*pi2 + dmsas
      zbn = z2/en

      ri = r*(vxi(i)-veta(j))/2.d0
      rmc = ri-c
      rmcba = rmc/a
      rbc = ri/c
      if (rbc .le. one) then
         call es (rmcba,s2rcba,s3rcba)
         zz2 = zbn*( dmsas + sabc3*s3rcba
     &        +rbc*( h3php-thabc2*s2rcba
     &        -half*rbc*rbc) )
      else
         call es (-rmcba,s2rcba,s3rcba)
         zz2 = z2 * ( one
     &        +thabc2 * ( rbc *s2rcba
     &        +tabc*s3rcba ) / en )
      endif
      
      if (iprint(132).ne.0) then
         if (abs(zz2-z2).gt.1.d-5) then
            write(*,*) i,j,ri,zz2
         endif
      endif

      end
